Backend API
<dx-chart
id="chart"
[dataSource]="dataSource"
[title]="title"
[palette]="['#00ced1', '#008000', '#ffd700', '#ff7f50']"
(onSeriesClick)="onSeriesClick($event)"
>
<dxo-common-series-settings type="bubble"></dxo-common-series-settings>
<dxo-export [enabled]="true"></dxo-export>
<dxo-legend position="inside" horizontalAlignment="left">
<dxo-border [visible]="true"></dxo-border>
</dxo-legend>
<dxo-argument-axis title="Total Population">
<dxo-label [customizeText]="argumentCustomizeText"></dxo-label>
</dxo-argument-axis>
<dxi-value-axis title="Population with Age over 60">
<dxo-label [customizeText]="valueCustomizeText"></dxo-label>
</dxi-value-axis>
<dxo-tooltip
[enabled]="true"
location="edge"
[customizeTooltip]="customizeTooltip"
>
</dxo-tooltip>
<dxi-series
*ngFor="let correlation of correlationSource"
[name]="correlation.name"
[argumentField]="correlation.argumentField"
[valueField]="correlation.valueField"
[sizeField]="correlation.sizeField"
[tagField]="correlation.tagField"
>
</dxi-series>
</dx-chart>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxChartModule, DxChartTypes } from 'devextreme-angular/ui/chart';
import { Population, CorrelationDescription, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
})
export class AppComponent {
title = 'Correlation between Total Population and\n Population with Age over 60';
dataSource: Population[];
correlationSource: CorrelationDescription[];
constructor(service: Service) {
this.dataSource = service.getPopulationData();
this.correlationSource = service.getCorrelationSource();
}
customizeTooltip = ({
point, argumentText, valueText, size,
}: { point: Record<string, unknown>, argumentText: string, valueText: string, size: number }) => ({
text: `${point.tag}<br/>Total Population: ${argumentText}M<br/>Population with Age over 60: ${valueText}M (${size}%)`,
});
argumentCustomizeText: DxChartTypes.ArgumentAxisLabel['customizeText'] = ({ value }) => `${value}M`;
valueCustomizeText: DxChartTypes.ValueAxisLabel['customizeText'] = ({ value }) => `${value}M`;
onSeriesClick({ target: series }: DxChartTypes.SeriesClickEvent) {
series.isVisible()
? series.hide()
: series.show();
}
}
@NgModule({
imports: [
BrowserModule,
DxChartModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #chart {
height: 440px;
}
import { Injectable } from '@angular/core';
export class Population {
total1: number;
total2?: number;
total3?: number;
total4?: number;
older1: number;
older2?: number;
older3?: number;
older4?: number;
perc1: number;
perc2?: number;
perc3?: number;
perc4?: number;
tag1: string;
tag2?: string;
tag3?: string;
tag4?: string;
}
export class CorrelationDescription {
name: string;
argumentField: string;
valueField: string;
sizeField: string;
tagField: string;
}
const populationData: Population[] = [{
total1: 9.5,
total2: 168.8,
total3: 127.2,
older1: 2.4,
older2: 8.8,
older3: 40.1,
perc1: 25.4,
perc2: 5.3,
perc3: 31.6,
tag1: 'Sweden',
tag2: 'Nigeria',
tag3: 'Japan',
}, {
total1: 82.8,
total2: 91.7,
total3: 90.8,
older1: 21.9,
older2: 4.6,
older3: 8.0,
perc1: 26.7,
perc2: 5.4,
perc3: 8.9,
tag1: 'Germany',
tag2: 'Ethiopia',
tag3: 'Viet Nam',
}, {
total1: 16.7,
total2: 80.7,
total3: 21.1,
older1: 3.8,
older2: 7.0,
older3: 2.7,
perc1: 22.8,
perc2: 8.4,
perc3: 12.9,
tag1: 'Netherlands',
tag2: 'Egypt',
tag3: 'Sri Lanka',
}, {
total1: 62.8,
total2: 52.4,
total3: 96.7,
older1: 14.4,
older2: 4.0,
older3: 5.9,
perc1: 23.0,
perc2: 7.8,
perc3: 6.1,
tag1: 'United Kingdom',
tag2: 'South Africa',
tag3: 'Philippines',
}, {
total1: 38.2,
total2: 43.2,
total3: 66.8,
older1: 7.8,
older2: 1.8,
older3: 9.6,
perc1: 20.4,
perc2: 4.3,
perc3: 13.7,
tag1: 'Poland',
tag2: 'Kenya',
tag3: 'Thailand',
}, {
total1: 45.5,
total3: 154.7,
total4: 34.8,
older1: 9.5,
older3: 10.3,
older4: 7.2,
perc1: 21.1,
perc3: 6.8,
perc4: 20.8,
tag1: 'Ukraine',
tag3: 'Bangladesh',
tag4: 'Canada',
}, {
total1: 143.2,
total4: 120.8,
older1: 26.5,
older4: 11.0,
perc1: 18.6,
perc4: 9.5,
tag1: 'Russian Federation',
tag4: 'Mexico',
}];
const correlationSource: CorrelationDescription[] = [{
name: 'Europe',
argumentField: 'total1',
valueField: 'older1',
sizeField: 'perc1',
tagField: 'tag1',
}, {
name: 'Africa',
argumentField: 'total2',
valueField: 'older2',
sizeField: 'perc2',
tagField: 'tag2',
}, {
name: 'Asia',
argumentField: 'total3',
valueField: 'older3',
sizeField: 'perc3',
tagField: 'tag3',
}, {
name: 'North America',
argumentField: 'total4',
valueField: 'older4',
sizeField: 'perc4',
tagField: 'tag4',
}];
@Injectable()
export class Service {
getPopulationData(): Population[] {
return populationData;
}
getCorrelationSource() : CorrelationDescription[] {
return correlationSource;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.24/package.json',
'npm:devexpress-gantt@4.1.64/package.json',
],
};
System.config(window.config);
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "17.3.12"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.4.5"
},
"zone.js": {
"version": "0.14.10"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.14.10/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Backend API
import React from 'react';
import {
Chart,
Series,
CommonSeriesSettings,
Legend,
ValueAxis,
ArgumentAxis,
Label,
Border,
Tooltip,
Export,
} from 'devextreme-react/chart';
import type { ChartTypes } from 'devextreme-react/chart';
import { dataSource } from './data.ts';
const palette: string[] = ['#00ced1', '#008000', '#ffd700', '#ff7f50'];
const customizeTooltip = (pointInfo: ChartTypes.BubblePointInfo): Record<string, string> => ({
text: `${pointInfo.point?.tag}<br/>Total Population: ${pointInfo.argumentText}M<br/>Population with Age over 60: ${pointInfo.valueText}M (${pointInfo.size}%)`,
});
function seriesClick(e: ChartTypes.SeriesClickEvent): void {
const series = e.target;
if (series.isVisible()) {
series.hide();
} else {
series.show();
}
}
const customizeText = (e: { value: string | number | Date }): string => `${e.value}M`;
function App() {
return (
<Chart
id="chart"
title={'Correlation between Total Population and\n Population with Age over 60'}
palette={palette}
onSeriesClick={seriesClick}
dataSource={dataSource}>
<Tooltip enabled={true} location="edge" customizeTooltip={customizeTooltip} />
<CommonSeriesSettings type="bubble" />
<ValueAxis title="Population with Age over 60">
<Label customizeText={customizeText} />
</ValueAxis>
<ArgumentAxis title="Total Population">
<Label customizeText={customizeText} />
</ArgumentAxis>
<Series
name="Europe"
argumentField="total1"
valueField="older1"
sizeField="perc1"
tagField="tag1"
/>
<Series
name="Africa"
argumentField="total2"
valueField="older2"
sizeField="perc2"
tagField="tag2"
/>
<Series
name="Asia"
argumentField="total3"
valueField="older3"
sizeField="perc3"
tagField="tag3"
/>
<Series
name="North America"
argumentField="total4"
valueField="older4"
sizeField="perc4"
tagField="tag4"
/>
<Legend position="inside" horizontalAlignment="left">
<Border visible={true} />
</Legend>
<Export enabled={true} />
</Chart>
);
}
export default App;
import React from 'react';
import {
Chart,
Series,
CommonSeriesSettings,
Legend,
ValueAxis,
ArgumentAxis,
Label,
Border,
Tooltip,
Export,
} from 'devextreme-react/chart';
import { dataSource } from './data.js';
const palette = ['#00ced1', '#008000', '#ffd700', '#ff7f50'];
const customizeTooltip = (pointInfo) => ({
text: `${pointInfo.point?.tag}<br/>Total Population: ${pointInfo.argumentText}M<br/>Population with Age over 60: ${pointInfo.valueText}M (${pointInfo.size}%)`,
});
function seriesClick(e) {
const series = e.target;
if (series.isVisible()) {
series.hide();
} else {
series.show();
}
}
const customizeText = (e) => `${e.value}M`;
function App() {
return (
<Chart
id="chart"
title={'Correlation between Total Population and\n Population with Age over 60'}
palette={palette}
onSeriesClick={seriesClick}
dataSource={dataSource}
>
<Tooltip
enabled={true}
location="edge"
customizeTooltip={customizeTooltip}
/>
<CommonSeriesSettings type="bubble" />
<ValueAxis title="Population with Age over 60">
<Label customizeText={customizeText} />
</ValueAxis>
<ArgumentAxis title="Total Population">
<Label customizeText={customizeText} />
</ArgumentAxis>
<Series
name="Europe"
argumentField="total1"
valueField="older1"
sizeField="perc1"
tagField="tag1"
/>
<Series
name="Africa"
argumentField="total2"
valueField="older2"
sizeField="perc2"
tagField="tag2"
/>
<Series
name="Asia"
argumentField="total3"
valueField="older3"
sizeField="perc3"
tagField="tag3"
/>
<Series
name="North America"
argumentField="total4"
valueField="older4"
sizeField="perc4"
tagField="tag4"
/>
<Legend
position="inside"
horizontalAlignment="left"
>
<Border visible={true} />
</Legend>
<Export enabled={true} />
</Chart>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const dataSource = [{
total1: 9.5,
total2: 168.8,
total3: 127.2,
older1: 2.4,
older2: 8.8,
older3: 40.1,
perc1: 25.4,
perc2: 5.3,
perc3: 31.6,
tag1: 'Sweden',
tag2: 'Nigeria',
tag3: 'Japan',
}, {
total1: 82.8,
total2: 91.7,
total3: 90.8,
older1: 21.9,
older2: 4.6,
older3: 8.0,
perc1: 26.7,
perc2: 5.4,
perc3: 8.9,
tag1: 'Germany',
tag2: 'Ethiopia',
tag3: 'Viet Nam',
}, {
total1: 16.7,
total2: 80.7,
total3: 21.1,
older1: 3.8,
older2: 7.0,
older3: 2.7,
perc1: 22.8,
perc2: 8.4,
perc3: 12.9,
tag1: 'Netherlands',
tag2: 'Egypt',
tag3: 'Sri Lanka',
}, {
total1: 62.8,
total2: 52.4,
total3: 96.7,
older1: 14.4,
older2: 4.0,
older3: 5.9,
perc1: 23.0,
perc2: 7.8,
perc3: 6.1,
tag1: 'United Kingdom',
tag2: 'South Africa',
tag3: 'Philippines',
}, {
total1: 38.2,
total2: 43.2,
total3: 66.8,
older1: 7.8,
older2: 1.8,
older3: 9.6,
perc1: 20.4,
perc2: 4.3,
perc3: 13.7,
tag1: 'Poland',
tag2: 'Kenya',
tag3: 'Thailand',
}, {
total1: 45.5,
total3: 154.7,
total4: 34.8,
older1: 9.5,
older3: 10.3,
older4: 7.2,
perc1: 21.1,
perc3: 6.8,
perc4: 20.8,
tag1: 'Ukraine',
tag3: 'Bangladesh',
tag4: 'Canada',
}, {
total1: 143.2,
total4: 120.8,
older1: 26.5,
older4: 11.0,
perc1: 18.6,
perc4: 9.5,
tag1: 'Russian Federation',
tag4: 'Mexico',
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const dataSource = [
{
total1: 9.5,
total2: 168.8,
total3: 127.2,
older1: 2.4,
older2: 8.8,
older3: 40.1,
perc1: 25.4,
perc2: 5.3,
perc3: 31.6,
tag1: 'Sweden',
tag2: 'Nigeria',
tag3: 'Japan',
},
{
total1: 82.8,
total2: 91.7,
total3: 90.8,
older1: 21.9,
older2: 4.6,
older3: 8.0,
perc1: 26.7,
perc2: 5.4,
perc3: 8.9,
tag1: 'Germany',
tag2: 'Ethiopia',
tag3: 'Viet Nam',
},
{
total1: 16.7,
total2: 80.7,
total3: 21.1,
older1: 3.8,
older2: 7.0,
older3: 2.7,
perc1: 22.8,
perc2: 8.4,
perc3: 12.9,
tag1: 'Netherlands',
tag2: 'Egypt',
tag3: 'Sri Lanka',
},
{
total1: 62.8,
total2: 52.4,
total3: 96.7,
older1: 14.4,
older2: 4.0,
older3: 5.9,
perc1: 23.0,
perc2: 7.8,
perc3: 6.1,
tag1: 'United Kingdom',
tag2: 'South Africa',
tag3: 'Philippines',
},
{
total1: 38.2,
total2: 43.2,
total3: 66.8,
older1: 7.8,
older2: 1.8,
older3: 9.6,
perc1: 20.4,
perc2: 4.3,
perc3: 13.7,
tag1: 'Poland',
tag2: 'Kenya',
tag3: 'Thailand',
},
{
total1: 45.5,
total3: 154.7,
total4: 34.8,
older1: 9.5,
older3: 10.3,
older4: 7.2,
perc1: 21.1,
perc3: 6.8,
perc4: 20.8,
tag1: 'Ukraine',
tag3: 'Bangladesh',
tag4: 'Canada',
},
{
total1: 143.2,
total4: 120.8,
older1: 26.5,
older4: 11.0,
perc1: 18.6,
perc4: 9.5,
tag1: 'Russian Federation',
tag4: 'Mexico',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart {
height: 440px;
}

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Charts - Bubble

This demo illustrates use of the bubble series type. This series can be used when you need to visualize a data set with three dimensions: the first two dimensions are indicated by coordinates on the axes, the third by the size of the bubble. In this demo, the bubble size helps estimate the percentage of people with age over 60 to the total population in the country.

www.wikipedia.org
Backend API
<template> <DxChart id="chart" :data-source="dataSource" :palette="palette" :title="'Correlation between Total Population and\n Population with Age over 60'" @series-click="seriesClick" > <DxCommonSeriesSettings type="bubble"/> <DxSeries name="Europe" argument-field="total1" value-field="older1" size-field="perc1" tag-field="tag1" /> <DxSeries name="Africa" argument-field="total2" value-field="older2" size-field="perc2" tag-field="tag2" /> <DxSeries name="Asia" argument-field="total3" value-field="older3" size-field="perc3" tag-field="tag3" /> <DxSeries name="North America" argument-field="total4" value-field="older4" size-field="perc4" tag-field="tag4" /> <DxArgumentAxis title="Total Population"> <DxLabel :customize-text="customizeText"/> </DxArgumentAxis> <DxValueAxis title="Population with Age over 60"> <DxLabel :customize-text="customizeText"/> </DxValueAxis> <DxLegend :visible="true" position="inside" horizontal-alignment="left" > <DxBorder :visible="true"/> </DxLegend> <DxTooltip :customize-tooltip="customizeTooltip" :enabled="true" location="edge" /> <DxExport :enabled="true"/> </DxChart> </template> <script setup lang="ts"> import { DxChart, DxSeries, DxCommonSeriesSettings, DxLegend, DxValueAxis, DxArgumentAxis, DxLabel, DxBorder, DxTooltip, DxExport, type DxChartTypes, } from 'devextreme-vue/chart'; import { dataSource } from './data.ts'; const palette = ['#00ced1', '#008000', '#ffd700', '#ff7f50']; const customizeText = (e: { value: string | number | Date }): string => `${e.value}M`; const customizeTooltip = (pointInfo: Record<string, any>): { text: string } => ({ text: `${pointInfo.point.tag}<br/>Total Population: ${pointInfo.argumentText}M<br/>Population with Age over 60: ${pointInfo.valueText}M (${pointInfo.size}%)`, }); function seriesClick(e: DxChartTypes.SeriesClickEvent): void { const series = e.target; if (series.isVisible()) { series.hide(); } else { series.show(); } } </script> <style> #chart { height: 440px; } </style>
window.exports = window.exports || {}; window.config = { transpiler: false, meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'typescript': { 'exports': 'ts', }, 'vue': { format: 'global', exports: 'Vue', esModule: true, }, 'vuex': { format: 'global', exports: 'Vuex', esModule: true, }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, 'anti-forgery': { loader: 'demo-ts-loader', }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.5.32/dist/vue.global.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'project:utils/demo-vue-loader.js', 'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'demo-ts-shared': 'project:utils/demo-ts-shared.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
export const dataSource = [{ total1: 9.5, total2: 168.8, total3: 127.2, older1: 2.4, older2: 8.8, older3: 40.1, perc1: 25.4, perc2: 5.3, perc3: 31.6, tag1: 'Sweden', tag2: 'Nigeria', tag3: 'Japan', }, { total1: 82.8, total2: 91.7, total3: 90.8, older1: 21.9, older2: 4.6, older3: 8.0, perc1: 26.7, perc2: 5.4, perc3: 8.9, tag1: 'Germany', tag2: 'Ethiopia', tag3: 'Viet Nam', }, { total1: 16.7, total2: 80.7, total3: 21.1, older1: 3.8, older2: 7.0, older3: 2.7, perc1: 22.8, perc2: 8.4, perc3: 12.9, tag1: 'Netherlands', tag2: 'Egypt', tag3: 'Sri Lanka', }, { total1: 62.8, total2: 52.4, total3: 96.7, older1: 14.4, older2: 4.0, older3: 5.9, perc1: 23.0, perc2: 7.8, perc3: 6.1, tag1: 'United Kingdom', tag2: 'South Africa', tag3: 'Philippines', }, { total1: 38.2, total2: 43.2, total3: 66.8, older1: 7.8, older2: 1.8, older3: 9.6, perc1: 20.4, perc2: 4.3, perc3: 13.7, tag1: 'Poland', tag2: 'Kenya', tag3: 'Thailand', }, { total1: 45.5, total3: 154.7, total4: 34.8, older1: 9.5, older3: 10.3, older4: 7.2, perc1: 21.1, perc3: 6.8, perc4: 20.8, tag1: 'Ukraine', tag3: 'Bangladesh', tag4: 'Canada', }, { total1: 143.2, total4: 120.8, older1: 26.5, older4: 11.0, perc1: 18.6, perc4: 9.5, tag1: 'Russian Federation', tag4: 'Mexico', }];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> <span v-if="false">Loading...</span> </div> </div> </body> </html>